// Program pro mereni s modulem PZEM-004T 100A vyuziva knihovnu " PZEM004T-v30-master " z webu picaxe.cc
// zobrazovani hodnot je na LCD displeji tabletu
// odecet se provede po zadani a odeslani hodnoty "1" z terminalu v tabletu
// vagnervlastimil@seznam.cz
// www.mojeelektronika.mzf.cz

#include <PZEM004Tv30.h>                                   // pripojeni knihovny pro ovladani PZEM 
PZEM004Tv30 pzem(11,12);                                   // PIN11 Arduino RXD na TXD PZEM , PIN12 Arduino TXD na RXD PZEM (11=2,12=3)
int hodnota;                                               // nadefinovani promenne pro spusteni odectu

void setup() {                                             // setup
Serial.begin(9600);                                        // nastaveni kmunikace s bluetooth
hodnota = 0;                                               // pocatecni hodnota
}                                                          // setup

void loop() {                                              // hlavni smycka
if (Serial.available() > 0){                               // testovani vstupu zda prisli data   
hodnota=Serial.parseInt();                                 // nacteni hodnoty pro spusteni odectu
if (hodnota == 1){                                         // pokud je hodnota rovena "1" pokracuje se na dalsim radku
Serial.println("ODECET HODNOT");                           // vypsani spusteni odectu na displej tabletu 
float voltage = pzem.voltage();                            // nacteni registru pro hodnotu napeti
if(voltage != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Napeti: ");Serial.print(voltage);Serial.println(" V");   // zobrazeni hodnoty napeti na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku
Serial.println("Chyba data napeti");                       // zobrazeni zpravy chyba nactenych dat                          
}                                                          // konec smycky IF napeti
float current = pzem.current();                            // nacteni registru pro hodnotu proud 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Proud: ");Serial.print(current);Serial.println(" A");    // zobrazeni hodnoty proudu na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku   
Serial.println("Chyba data proud");                        // zobrazeni zpravy chyba nactenych dat   
}                                                          // konec smycky IF proud
float power = pzem.power();                                // nacteni registru pro hodnotu odberu ve WATTECH 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Odber: ");Serial.print(power);Serial.println(" W");      // zobrazeni hodnoty odberu na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data odber");                        // zobrazeni zpravy chyba nactenych dat   
}                                                          // konec smycky IF odber
float energy = pzem.energy();                              // nacteni registru pro hodnotu spotreby v kWh 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Spotreba: ");Serial.print(energy,3);Serial.println(" kWh"); // zobrazeni hodnoty spotreby kWh na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data spotreba");                     // zobrazeni zpravy chyba nactenych dat 
}                                                          // konec smycky IF spotreba kWh
float frequency = pzem.frequency();                        // nacteni registru pro hodnotu frekvence site 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Frekvence: ");Serial.print(frequency, 1);Serial.println(" Hz"); // zobrazeni hodnoty frekvence na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data frekvence");                    // zobrazeni zpravy chyba nactenych dat  
}                                                          // konec smycky IF frekvence
float pf = pzem.pf();                                      // nacteni registru pro hodnotu kosinus FI site 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Ucinik: ");Serial.println(pf);               // zobrazeni hodnoty kosinus FI na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku 
Serial.println("Chyba data ucinik");                       // zobrazeni zpravy chyba nactenych dat  
}                                                          // konec smycky IF ucinik PF                                                     
}                                                          // konec smycky IF odecet
hodnota = 0;                                               // ulozeni hodnoty do promenne
Serial.println();                                          // vynechani radku v terminalu na lCD tabletu
}                                                          // konec smycky IF BP.available 
delay(1000);                                               // casova prodleva pro dalsi nacteni dat
}                                                          // konec hlavni smycky LOOP
